#if !defined(PROM_NO_FEI)
#include "cfei_prometheus.h"

#ifdef __cplusplus
extern "C" {
#endif
  const char *Prometheus_LSC_GetVersion(LinSysCore* lsc) {
    Prometheus_LinSysCore* linSys = (Prometheus_LinSysCore*)lsc->lsc_;
    return linSys->version_no_; // eg, "1.5.7"
  }
#ifdef __cplusplus
}
#endif

/*============================================================================*/
/* Create function for a Prometheus_LinSysCore object.
*/
LinearSystemCore *Prometheus_base_create( MPI_Comm comm ) 
{
  Prometheus_LinSysCore* linSys = new Prometheus_LinSysCore(comm);
  return (linSys);
}


/*============================================================================*/
/* Create function for a Prometheus_LinSysCore object.
*/
extern "C" int Prometheus_LinSysCore_create(LinSysCore** lsc, 
				       MPI_Comm comm) {

   Prometheus_LinSysCore* linSys = new Prometheus_LinSysCore(comm);

   if (linSys == NULL) return(1);

   *lsc = new LinSysCore;

   if (*lsc == NULL) return(1);

   (*lsc)->lsc_ = (void*)linSys;

   return(0);
}

/*============================================================================*/
/* Destroy function, to de-allocate a Prometheus_LinSysCore object.
*/
extern "C" int Prometheus_LinSysCore_destroy(LinSysCore** lsc) {

   if (*lsc == NULL) return(1);

   Prometheus_LinSysCore* linSys = (Prometheus_LinSysCore*)((*lsc)->lsc_);

   if (linSys == NULL) return(1);

   delete linSys;

   delete *lsc;
   *lsc = NULL;

   return(0);
}
#endif
